Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 166)
@@ -114,4 +114,8 @@
 {
   m_aiNumRefIdx[0] = m_aiNumRefIdx[1] = m_aiNumRefIdx[2] = 0;
+
+#if FORCE_REF_VSP
+  m_iRefIdxVsp[0] = m_iRefIdxVsp[1] = NOT_VALID;
+#endif
   
   initEqualRef();
@@ -139,4 +143,8 @@
   resetWpScalingLC(m_weightPredTableLC);
   initWpAcDcParam();
+
+#if VSP_SLICE_HEADER
+  m_bVspFlag = false;
+#endif
 }
 
@@ -185,4 +193,8 @@
   m_numEntryPointOffsets = 0;
 #endif
+#if VSP_SLICE_HEADER
+  m_bVspFlag = false;
+#endif
+
 }
 
@@ -407,5 +419,9 @@
 }
 
+#if VSP_N
+Void TComSlice::setRefPicListMvc( TComList<TComPic*>& rcListPic, std::vector<TComPic*>& rapcInterViewRefPics, TComPic* pcVspPic )
+#else
 Void TComSlice::setRefPicListMvc( TComList<TComPic*>& rcListPic, std::vector<TComPic*>& rapcInterViewRefPics )
+#endif
 {
   if( m_eSliceType == I_SLICE )
@@ -422,4 +438,7 @@
   TComPic*  RefPicSetLtCurr [16];
   TComPic*  RefPicSetIvCurr [16];
+#if VSP_N
+  TComPic*  RefPicSetVspCurr [16] = {NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL}; //for Linux comp
+#endif
 
   UInt NumPocStCurr0 = 0;
@@ -427,4 +446,7 @@
   UInt NumPocLtCurr  = 0;
   UInt NumPocIvCurr  = 0;
+#if VSP_N
+  UInt NumPocVspCurr  = 0;
+#endif
 
   Int i;
@@ -474,4 +496,14 @@
     NumPocIvCurr++;
   }
+#if VSP_N
+  if( pcVspPic )
+  {
+    pcRefPic = pcVspPic;
+    pcRefPic->setIsLongTerm( 0 );
+    pcRefPic->getPicYuvRec()->extendPicBorder();
+    RefPicSetVspCurr[NumPocVspCurr] = pcRefPic;
+    NumPocVspCurr++;
+  }
+#endif
 
   // ref_pic_list_init
@@ -481,6 +513,11 @@
 
   assert( (NumPocStCurr0 + NumPocStCurr1 + NumPocLtCurr + NumPocIvCurr) == getNumPocTotalCurrMvc() );
+#if VSP_N
+  Int numRpsCurrTempList0 = max( (num_ref_idx_l0_active_minus1 + 1), (NumPocStCurr0 + NumPocStCurr1 + NumPocLtCurr + NumPocIvCurr + NumPocVspCurr) );
+  Int numRpsCurrTempList1 = max( (num_ref_idx_l1_active_minus1 + 1), (NumPocStCurr0 + NumPocStCurr1 + NumPocLtCurr + NumPocIvCurr + NumPocVspCurr) );
+#else
   Int numRpsCurrTempList0 = max( (num_ref_idx_l0_active_minus1 + 1), (NumPocStCurr0 + NumPocStCurr1 + NumPocLtCurr + NumPocIvCurr) );
   Int numRpsCurrTempList1 = max( (num_ref_idx_l1_active_minus1 + 1), (NumPocStCurr0 + NumPocStCurr1 + NumPocLtCurr + NumPocIvCurr) );
+#endif
 
   assert( numRpsCurrTempList0 <= 16 );
@@ -509,5 +546,17 @@
   for( cIdx = 0; cIdx <= num_ref_idx_l0_active_minus1; cIdx ++ )
   {
+#if VSP_N
+    if( pcVspPic && cIdx == num_ref_idx_l0_active_minus1 )
+    {
+      m_apcRefPicList[0][cIdx] = RefPicSetVspCurr[0];
+#if FORCE_REF_VSP
+      m_iRefIdxVsp[0] = cIdx;
+#endif
+    }
+    else
+      m_apcRefPicList[0][cIdx] = m_RefPicListModification.getRefPicListModificationFlagL0() ? refPicListTemp0[ m_RefPicListModification.getRefPicSetIdxL0(cIdx) ] : refPicListTemp0[cIdx];
+#else
     m_apcRefPicList[0][cIdx] = m_RefPicListModification.getRefPicListModificationFlagL0() ? refPicListTemp0[ m_RefPicListModification.getRefPicSetIdxL0(cIdx) ] : refPicListTemp0[cIdx];
+#endif
   }
   if( m_eSliceType == P_SLICE )
@@ -520,5 +569,17 @@
     for( cIdx = 0; cIdx <= num_ref_idx_l1_active_minus1; cIdx ++ )
     {
+#if VSP_N
+      if( pcVspPic && cIdx == num_ref_idx_l1_active_minus1 )
+      {
+        m_apcRefPicList[1][cIdx] = RefPicSetVspCurr[0];
+#if FORCE_REF_VSP
+        m_iRefIdxVsp[1] = cIdx;
+#endif
+      }
+      else
+        m_apcRefPicList[1][cIdx] = m_RefPicListModification.getRefPicListModificationFlagL1() ? refPicListTemp1[ m_RefPicListModification.getRefPicSetIdxL1(cIdx) ] : refPicListTemp1[cIdx];
+#else
       m_apcRefPicList[1][cIdx] = m_RefPicListModification.getRefPicListModificationFlagL1() ? refPicListTemp1[ m_RefPicListModification.getRefPicSetIdxL1(cIdx) ] : refPicListTemp1[cIdx];
+#endif
     }
   }
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 166)
@@ -45,5 +45,4 @@
 #include "TComRom.h"
 #include "TComList.h"
-
 //! \ingroup TLibCommon
 //! \{
@@ -1269,5 +1268,13 @@
 
 #if SONY_COLPIC_AVAILABILITY
-  Int         m_iViewOrderIdx;
+  Int        m_iViewOrderIdx;
+#endif
+
+#if FORCE_REF_VSP
+  Int        m_iRefIdxVsp[2]; // L0/L1
+#endif
+
+#if VSP_SLICE_HEADER
+  Bool      m_bVspFlag;
 #endif
 
@@ -1411,5 +1418,9 @@
   Int       getNumPocTotalCurr();
   Int       getNumPocTotalCurrMvc();
+#if VSP_N
+  Void      setRefPicListMvc    ( TComList<TComPic*>& rcListPic, std::vector<TComPic*>& rapcInterViewRefPics, TComPic* pcVspPic );
+#else
   Void      setRefPicListMvc    ( TComList<TComPic*>& rcListPic, std::vector<TComPic*>& rapcInterViewRefPics );
+#endif
   Void      setRefPOCnViewListsMvc();
 
@@ -1565,4 +1576,14 @@
   Int*      getInvCodedOffset     ()  { return m_aaiCodedOffset[1]; }
 
+#if FORCE_REF_VSP
+  Void      setRefIdxVsp ( Int idx, Int refList ) { m_iRefIdxVsp[refList] = idx; }
+  Int       getRefIdxVsp ( Int refList )          { return m_iRefIdxVsp[refList]; }
+#endif
+
+#if VSP_SLICE_HEADER
+  Void      setVspFlag          ( Bool val )    { m_bVspFlag = val; }
+  Bool      getVspFlag          ()              { return m_bVspFlag; }
+#endif
+
 protected:
   TComPic*  xGetRefPic        (TComList<TComPic*>& rcListPic, UInt uiPOC);
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComYuv.h
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComYuv.h	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComYuv.h	(revision 166)
@@ -213,4 +213,13 @@
 
   __inline Pel  xClip  (Pel x )      { return ( (x < 0) ? 0 : (x > (Pel)g_uiIBDI_MAX) ? (Pel)g_uiIBDI_MAX : x ); }
+
+#if DEBUGIMGOUT
+public:
+  Void colsetToPicYuv   ( const UChar ucColor[3],                 Int iOffset[2][2], TComPicYuv* pcPicYuvDst, UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth = 0, UInt uiPartIdx = 0 );
+  Void colsetToPicLuma  ( const UChar ucLumaOffCol,               Int iOffset[2][2], TComPicYuv* pcPicYuvDst, UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth = 0, UInt uiPartIdx = 0 );
+  Void colsetToPicChroma( const UChar ucUCol, const UChar ucVCol, Int iOffset[2][2], TComPicYuv* pcPicYuvDst, UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth = 0, UInt uiPartIdx = 0 );
+  Void drawLineToPicYuv ( bool bHor, bool bVer, UInt uiSize,      TComPicYuv* pcPicYuvDst, UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth = 0, UInt uiPartIdx = 0 );
+#endif
+
 };// END CLASS DEFINITION TComYuv
 
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TypeDef.h	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TypeDef.h	(revision 166)
@@ -42,4 +42,23 @@
 //! \{
 
+#define VSP_N                             1
+#if VSP_N
+#define VSP_TEXT_ONLY                     1
+#define NUM_VIEW_VSP                      99
+#define VSP_N_DUMP                        0
+#define FORCE_REF_VSP                     2   // 0=NotUseVSPSKIP 1:VSPSKIPforFlag 2:VSPSKIPforMergeIdx
+#define VSP_MV_ZERO                       0   // use zero vector for VSP
+#if VSP_MV_ZERO
+#define AMVP_VSP_UNAVAILABLE              1
+#endif
+#define VSP_MERGE_POS                     5   // position of vsp in merge list (0..5)
+#define NTT_SUBPEL                        1
+#endif
+#define DEBUGIMGOUT                       0   //Debug YUVImage Out
+#define DEBUGLOGOUT                       0   //Debug Log Out
+
+#define VSP_SLICE_HEADER                  1
+#define VSP_FRAME_INTERVAL                2
+
 #define FIXES                             1
 #define POZNAN_CABAC_INIT_FLAG_FIX        1
@@ -115,5 +134,5 @@
 #define HHI_FULL_PEL_DEPTH_MAP_MV_ACC     1   // full-pel mv accuracy for depth maps
                                        
-#if HHI_INTER_VIEW_MOTION_PRED         
+#if HHI_INTER_VIEW_MOTION_PRED
 #define SAIT_IMPROV_MOTION_PRED_M24829    1   // improved inter-view motion vector prediction
 #else                                  
@@ -727,4 +746,7 @@
   MODE_INTER,           ///< inter-prediction mode
   MODE_INTRA,           ///< intra-prediction mode
+#if FORCE_REF_VSP==1
+  MODE_SYNTH,           ///< synth-mode
+#endif
   MODE_NONE = 15
 };
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecCAVLC.cpp
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 166)
@@ -2348,4 +2348,16 @@
 #endif
 
+#if VSP_SLICE_HEADER
+  if( rpcSlice->getSPS()->getViewId()!=0 
+#if VSP_TEXT_ONLY
+      && !(rpcSlice->getSPS()->isDepth()) 
+#endif
+    )
+  {
+    READ_FLAG( uiCode, "vsp_flag" );
+    rpcSlice->setVspFlag( uiCode ? true : false );
+  }
+#endif
+
   if (!bEntropySlice)
   {
@@ -2601,4 +2613,11 @@
 }
 
+#if FORCE_REF_VSP==1
+Void TDecCavlc::parseVspFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
+{
+  assert(0);
+}
+#endif
+
 #if HHI_INTER_VIEW_MOTION_PRED
 Void TDecCavlc::parseMVPIdx( Int& riMVPIdx, Int iAMVPCands )
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecCAVLC.h
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecCAVLC.h	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecCAVLC.h	(revision 166)
@@ -142,4 +142,7 @@
   
   Void  parseSkipFlag       ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
+#if FORCE_REF_VSP==1
+  Void  parseVspFlag        ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
+#endif
   Void parseMergeFlag       ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth, UInt uiPUIdx );
   Void parseMergeIndex      ( TComDataCU* pcCU, UInt& ruiMergeIndex, UInt uiAbsPartIdx, UInt uiDepth );
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecCu.cpp
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecCu.cpp	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecCu.cpp	(revision 166)
@@ -52,4 +52,8 @@
   m_ppcYuvResPred = NULL;
 #endif
+#if FORCE_REF_VSP
+  m_ppcYuvAvail   = NULL;
+  m_ppcYuvSynth   = NULL;
+#endif
   m_ppcCU      = NULL;
 }
@@ -79,4 +83,8 @@
 #if HHI_INTER_VIEW_RESIDUAL_PRED
   m_ppcYuvResPred = new TComYuv*   [m_uiMaxDepth-1];
+#endif
+#if FORCE_REF_VSP
+  m_ppcYuvAvail   = new TComYuv*    [m_uiMaxDepth-1];
+  m_ppcYuvSynth   = new TComYuv*    [m_uiMaxDepth-1];
 #endif
   m_ppcCU      = new TComDataCU*[m_uiMaxDepth-1];
@@ -94,4 +102,8 @@
     m_ppcYuvResPred[ui] = new TComYuv;    m_ppcYuvResPred[ui]->create( uiWidth, uiHeight );
 #endif
+#if FORCE_REF_VSP
+    m_ppcYuvAvail  [ui] = new TComYuv;    m_ppcYuvAvail  [ui]->create( uiWidth, uiHeight );
+    m_ppcYuvSynth  [ui] = new TComYuv;    m_ppcYuvSynth  [ui]->create( uiWidth, uiHeight );
+#endif
     m_ppcCU     [ui] = new TComDataCU; m_ppcCU     [ui]->create( uiNumPartitions, uiWidth, uiHeight, true, uiMaxWidth >> (m_uiMaxDepth - 1) );
   }
@@ -118,4 +130,8 @@
     m_ppcYuvResPred[ui]->destroy(); delete m_ppcYuvResPred[ui]; m_ppcYuvResPred[ui] = NULL;
 #endif
+#if FORCE_REF_VSP
+    m_ppcYuvAvail  [ui]->destroy(); delete m_ppcYuvAvail  [ui]; m_ppcYuvAvail  [ui] = NULL;
+    m_ppcYuvSynth  [ui]->destroy(); delete m_ppcYuvSynth  [ui]; m_ppcYuvSynth  [ui] = NULL;
+#endif
     m_ppcCU     [ui]->destroy(); delete m_ppcCU     [ui]; m_ppcCU     [ui] = NULL;
   }
@@ -125,4 +141,8 @@
 #if HHI_INTER_VIEW_RESIDUAL_PRED
   delete [] m_ppcYuvResPred; m_ppcYuvResPred = NULL;
+#endif
+#if FORCE_REF_VSP
+  delete [] m_ppcYuvAvail;   m_ppcYuvAvail   = NULL;
+  delete [] m_ppcYuvSynth;   m_ppcYuvSynth   = NULL;
 #endif
   delete [] m_ppcCU     ; m_ppcCU      = NULL;
@@ -328,7 +348,20 @@
   {
     m_pcEntropyDecoder->decodeSkipFlag( pcCU, uiAbsPartIdx, uiDepth );
+
+#if FORCE_REF_VSP==1
+    if( pcCU->isSkipped(uiAbsPartIdx) && pcCU->getSlice()->getViewId() != 0 )
+#if VSP_TEXT_ONLY
+    if( !pcCU->getSlice()->getSPS()->isDepth() )
+#endif
+    {
+      m_pcEntropyDecoder->decodeVspFlag( pcCU, uiAbsPartIdx, uiDepth );
+    }
+#endif
   }
  
   if( pcCU->isSkipped(uiAbsPartIdx) )
+#if FORCE_REF_VSP==1
+  if( !pcCU->isVspMode(uiAbsPartIdx) )
+#endif
   {
     m_ppcCU[uiDepth]->copyInterPredInfoFrom( pcCU, uiAbsPartIdx, REF_PIC_LIST_0 );
@@ -352,6 +385,14 @@
     if( pcCU->getTextureModeDepth( uiAbsPartIdx ) == uiDepth )
     {
+#if DEBUGLOGOUT
+      PredMode   eOrgPred = pcCU->getPredictionMode( uiAbsPartIdx );
+#endif
       TComDataCU *pcTextureCU = pcCU->getSlice()->getTexturePic()->getCU( pcCU->getAddr() );
       pcCU->copyTextureMotionDataFrom( pcTextureCU, uiDepth, pcCU->getZorderIdxInCU() + uiAbsPartIdx, uiAbsPartIdx );
+#if DEBUGLOGOUT
+      if( eOrgPred == MODE_SKIP )
+        pcCU->setPredModeSubParts( MODE_SKIP, uiAbsPartIdx, uiDepth );
+      m_cDebug.DebugLogOut( pcCU, uiAbsPartIdx, uiDepth );
+#endif
 
       UInt uiCurrPartNumb = pcCU->getPic()->getNumPartInCU() >> (uiDepth << 1);
@@ -396,6 +437,45 @@
 #endif
     xFinishDecodeCU( pcCU, uiAbsPartIdx, uiDepth, ruiIsLast );
+#if DEBUGLOGOUT
+#if HHI_MPI
+    if( pcCU->getTextureModeDepth( uiAbsPartIdx ) != uiDepth )
+#endif
+      m_cDebug.DebugLogOut( pcCU, uiAbsPartIdx, uiDepth );
+#endif
     return;
   }
+
+#if FORCE_REF_VSP==1
+  if( pcCU->isVspMode( uiAbsPartIdx ) )
+  {
+    TComMv cMvZero;
+
+    pcCU->setPartSizeSubParts( SIZE_2Nx2N, uiAbsPartIdx, uiDepth );
+    pcCU->setSizeSubParts( g_uiMaxCUWidth>>uiDepth, g_uiMaxCUHeight>>uiDepth, uiAbsPartIdx, uiDepth );
+
+    pcCU->getCUMvField(REF_PIC_LIST_0)->setAllMvField( TComMvField(), SIZE_2Nx2N, uiAbsPartIdx, uiDepth, 0 );
+    pcCU->getCUMvField(REF_PIC_LIST_1)->setAllMvField( TComMvField(), SIZE_2Nx2N, uiAbsPartIdx, uiDepth, 0 );
+    pcCU->getCUMvField(REF_PIC_LIST_0)->setAllMvd    ( cMvZero,       SIZE_2Nx2N, uiAbsPartIdx, uiDepth, 0 );
+    pcCU->getCUMvField(REF_PIC_LIST_1)->setAllMvd    ( cMvZero,       SIZE_2Nx2N, uiAbsPartIdx, uiDepth, 0 );
+
+    //pcCU->getCUMvField(REF_PIC_LIST_0)->setAllRefIdx ( pcCU->getSlice()->getRefIdxVsp(REF_PIC_LIST_0), SIZE_2Nx2N, 0, pcCU->getDepth(0), 0 );
+    //pcCU->getCUMvField(REF_PIC_LIST_1)->setAllRefIdx ( pcCU->getSlice()->getRefIdxVsp(REF_PIC_LIST_1), SIZE_2Nx2N, 0, pcCU->getDepth(0), 0 );
+
+    pcCU->setMVPIdxSubParts( -1, REF_PIC_LIST_0, uiAbsPartIdx, 0, uiDepth );
+    pcCU->setMVPNumSubParts( -1, REF_PIC_LIST_0, uiAbsPartIdx, 0, uiDepth );
+    pcCU->setMVPIdxSubParts( -1, REF_PIC_LIST_1, uiAbsPartIdx, 0, uiDepth );
+    pcCU->setMVPNumSubParts( -1, REF_PIC_LIST_1, uiAbsPartIdx, 0, uiDepth );
+
+    pcCU->setCbfSubParts( 0, 0, 0, uiAbsPartIdx, uiDepth );
+    pcCU->setTrIdxSubParts( 0 , uiAbsPartIdx, uiDepth );
+    pcCU->setNSQTIdxSubParts( uiAbsPartIdx, uiDepth );
+
+    xFinishDecodeCU( pcCU, uiAbsPartIdx, uiDepth, ruiIsLast );
+#if DEBUGLOGOUT
+    m_cDebug.DebugLogOut( pcCU, uiAbsPartIdx, uiDepth );
+#endif
+    return;
+  }
+#endif
 
 #if HHI_MPI
@@ -428,4 +508,7 @@
     {
       xFinishDecodeCU( pcCU, uiAbsPartIdx, uiDepth, ruiIsLast );
+#if DEBUGLOGOUT
+      m_cDebug.DebugLogOut( pcCU, uiAbsPartIdx, uiDepth );
+#endif
       return;
     }
@@ -527,4 +610,7 @@
   setdQPFlag( bCodeDQP );
   xFinishDecodeCU( pcCU, uiAbsPartIdx, uiDepth, ruiIsLast );
+#if DEBUGLOGOUT
+  m_cDebug.DebugLogOut( pcCU, uiAbsPartIdx, uiDepth );
+#endif
 }
 
@@ -553,4 +639,8 @@
 {
   TComPic* pcPic = pcCU->getPic();
+#if FORCE_REF_VSP
+  if(pcPic->getPicYuvSynth())  m_ppcYuvSynth[uiDepth]->copyFromPicYuv( pcPic->getPicYuvSynth(), pcCU->getAddr(), uiAbsPartIdx );
+  if(pcPic->getPicYuvAvail())  m_ppcYuvAvail[uiDepth]->copyFromPicYuv( pcPic->getPicYuvAvail(), pcCU->getAddr(), uiAbsPartIdx );
+#endif
   
   Bool bBoundary = false;
@@ -603,4 +693,9 @@
       xReconIntraQT( m_ppcCU[uiDepth], uiAbsPartIdx, uiDepth );
       break;
+#if FORCE_REF_VSP==1
+    case MODE_SYNTH:
+      m_ppcYuvReco[uiDepth]->copyFromPicYuv(pcPic->getPicYuvSynth(), pcCU->getAddr(), uiAbsPartIdx);
+      break;
+#endif
     default:
       assert(0);
@@ -615,4 +710,7 @@
   
   xCopyToPic( m_ppcCU[uiDepth], pcPic, uiAbsPartIdx, uiDepth );
+#if DEBUGIMGOUT
+  xColsetToPicMerge( m_ppcCU[uiDepth], pcPic->getPicYuvRecDbg(), uiAbsPartIdx, uiDepth );
+#endif
 }
 
@@ -626,5 +724,4 @@
   // inter prediction
   m_pcPrediction->motionCompensation( pcCU, m_ppcYuvReco[uiDepth] );
-  
 #if HHI_MPI
   if( pcCU->getTextureModeDepth( 0 ) != -1 )
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecCu.h
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecCu.h	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecCu.h	(revision 166)
@@ -46,4 +46,7 @@
 #include "TLibCommon/TComPrediction.h"
 #include "TDecEntropy.h"
+#if DEBUGIMGOUT || DEBUGLOGOUT
+#include "TLibCommon/DebugLog.h"
+#endif
 
 //! \ingroup TLibDecoder
@@ -64,4 +67,8 @@
   TComYuv**           m_ppcYuvResPred;    ///< residual prediction buffer
 #endif
+#if VSP_N
+  TComYuv**           m_ppcYuvAvail;      ///< array of available map buffer
+  TComYuv**           m_ppcYuvSynth;      ///< array of synth buffer
+#endif
   TComDataCU**        m_ppcCU;            ///< CU data array
   
@@ -77,4 +84,8 @@
   virtual ~TDecCu();
   
+#if DEBUGLOGOUT
+  DebugLog            m_cDebug;
+#endif
+
   /// initialize access channels
   Void  init                    ( TDecEntropy* pcEntropyDecoder, TComTrQuant* pcTrQuant, TComPrediction* pcPrediction );
@@ -121,4 +132,8 @@
   Void xFillPCMBuffer           (TComDataCU* pCU, UInt absPartIdx, UInt depth);
 #endif
+#if DEBUGIMGOUT
+  Void xColsetToPic             ( TComDataCU* pcCU, TComPicYuv* pcPicYuv, UInt uiZorderIdx, UInt uiDepth );
+  Void xColsetToPicMerge        ( TComDataCU* pcCU, TComPicYuv* pcPicYuv, UInt uiZorderIdx, UInt uiDepth );
+#endif
 };
 
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecEntropy.cpp
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 166)
@@ -54,4 +54,11 @@
 }
 
+#if FORCE_REF_VSP==1
+Void TDecEntropy::decodeVspFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
+{
+  m_pcEntropyDecoderIf->parseVspFlag( pcCU, uiAbsPartIdx, uiDepth );
+}
+#endif
+
 /** decode merge flag
  * \param pcSubCU
@@ -301,6 +308,21 @@
         {
           decodeRefFrmIdxPU( pcCU,    uiSubPartIdx,              uiDepth, uiPartIdx, RefPicList( uiRefListIdx ) );
+#if VSP_MV_ZERO
+          Int iRefIdx = pcCU->getCUMvField( RefPicList( uiRefListIdx ) )->getRefIdx(uiSubPartIdx);
+          if( pcCU->getSlice()->getViewId() && iRefIdx >= 0 && (pcCU->getSlice()->getRefViewId( RefPicList( uiRefListIdx ), iRefIdx ) == NUM_VIEW_VSP) )
+          {
+            pcCU->getCUMvField( RefPicList( uiRefListIdx ) )->setAllMvd( TComMv(0, 0), pcCU->getPartitionSize( uiSubPartIdx ), uiSubPartIdx, uiDepth, uiPartIdx );
+            pcCU->getCUMvField( RefPicList( uiRefListIdx ) )->setAllMv ( TComMv(0, 0), pcCU->getPartitionSize( uiSubPartIdx ), uiSubPartIdx, uiDepth, uiPartIdx );
+            pcCU->setMVPIdxSubParts( -1, RefPicList( uiRefListIdx ), uiSubPartIdx, uiPartIdx, pcCU->getDepth(uiSubPartIdx));
+            pcCU->setMVPNumSubParts( -1, RefPicList( uiRefListIdx ), uiSubPartIdx, uiPartIdx, pcCU->getDepth(uiSubPartIdx));
+          }
+          else
+          {
+#endif
           decodeMvdPU      ( pcCU,    uiSubPartIdx,              uiDepth, uiPartIdx, RefPicList( uiRefListIdx ) );
           decodeMVPIdxPU   ( pcSubCU, uiSubPartIdx-uiAbsPartIdx, uiDepth, uiPartIdx, RefPicList( uiRefListIdx ) );
+#if VSP_MV_ZERO
+          }
+#endif
         }
       }
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecEntropy.h
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecEntropy.h	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecEntropy.h	(revision 166)
@@ -103,4 +103,7 @@
 public:
   virtual Void parseSkipFlag      ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth ) = 0;
+#if FORCE_REF_VSP==1
+  virtual Void parseVspFlag       ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth ) = 0;
+#endif
   virtual Void parseSplitFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth ) = 0;
   virtual Void parseMergeFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth, UInt uiPUIdx ) = 0;
@@ -196,4 +199,7 @@
   Void decodeSplitFlag         ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
   Void decodeSkipFlag          ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
+#if FORCE_REF_VSP==1
+  Void decodeVspFlag           ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
+#endif
   Void decodeMergeFlag         ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth, UInt uiPUIdx );
   Void decodeMergeIndex        ( TComDataCU* pcSubCU, UInt uiPartIdx, UInt uiPartAddr, PartSize eCUMode, UChar* puhInterDirNeighbours, TComMvField* pcMvFieldNeighbours, UInt uiDepth );
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecSbac.cpp
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 166)
@@ -578,4 +578,30 @@
 }
 
+#if FORCE_REF_VSP==1
+Void TDecSbac::parseVspFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
+{
+  if( pcCU->getSlice()->isIntra() || pcCU->getSlice()->getViewId()==0 )
+  {
+    return;
+  }
+  
+  UInt uiSymbol = 0;
+  UInt uiCtxSkip = pcCU->getCtxSkipFlag( uiAbsPartIdx );
+  m_pcTDecBinIf->decodeBin( uiSymbol, m_cCUSkipFlagSCModel.get( 0, 0, uiCtxSkip ) );
+  DTRACE_CABAC_VL( g_nSymbolCounter++ );
+  DTRACE_CABAC_T( "\tVspFlag" );
+  DTRACE_CABAC_T( "\tuiCtxSkip: ");
+  DTRACE_CABAC_V( uiCtxSkip );
+  DTRACE_CABAC_T( "\tuiSymbol: ");
+  DTRACE_CABAC_V( uiSymbol );
+  DTRACE_CABAC_T( "\n");
+  
+  if( uiSymbol )
+  {
+    pcCU->setPredModeSubParts( MODE_SYNTH, uiAbsPartIdx, uiDepth );
+  }
+}
+#endif
+
 /** parse merge flag
  * \param pcCU
@@ -610,5 +636,14 @@
   uiNumCand = pcCU->getSlice()->getMaxNumMergeCand();
 #if HHI_MPI
+#if VSP_TEXT_ONLY
+  TComDataCU* pcTextCU = pcCU->getSlice()->getSPS()->getUseMVI() ? pcCU->getSlice()->getTexturePic()->getCU( pcCU->getAddr() ) : NULL;
+  Int aiRefIdxVsp[2] = { pcTextCU ? pcTextCU->getCUMvField( RefPicList(0) )->getRefIdx( uiAbsPartIdx ) : -1,
+                         pcTextCU ? pcTextCU->getCUMvField( RefPicList(1) )->getRefIdx( uiAbsPartIdx ) : -1 };
+  const Bool bMVIAvailable = pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE
+    && !( aiRefIdxVsp[0] >= 0 && pcTextCU->getSlice()->getRefViewId( RefPicList(0), aiRefIdxVsp[0] ) == NUM_VIEW_VSP )
+    && !( aiRefIdxVsp[1] >= 0 && pcTextCU->getSlice()->getRefViewId( RefPicList(1), aiRefIdxVsp[1] ) == NUM_VIEW_VSP );
+#else
   const Bool bMVIAvailable = pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE;
+#endif
   const UInt uiMviMergePos = bMVIAvailable ? HHI_MPI_MERGE_POS : uiNumCand;
 #endif
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecSbac.h
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecSbac.h	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecSbac.h	(revision 166)
@@ -166,4 +166,7 @@
 
   Void parseSkipFlag      ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
+#if FORCE_REF_VSP==1
+  Void parseVspFlag       ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
+#endif
   Void parseSplitFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth );
   Void parseMergeFlag     ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth, UInt uiPUIdx );
Index: branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecSlice.cpp
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecSlice.cpp	(revision 165)
+++ branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecSlice.cpp	(revision 166)
@@ -102,4 +102,9 @@
   rpcPic->setPicYuvResi( 0 );
   
+#if DEBUGLOGOUT
+  char fname[128];
+  sprintf(fname, "%sV%02d_%05d%s.csv", "DecLog", rpcPic->getSlice(0)->getViewId(), rpcPic->getPOC(), rpcPic->getSlice(0)->getIsDepth() ? "depth":"text");
+  m_pcCuDecoder->m_cDebug.DebugLogFileOpen( fname );
+#endif
 #if ENC_DEC_TRACE
   g_bJustDoIt = g_bEncDecTraceEnable;
@@ -439,4 +444,7 @@
 #endif
   }
+#if DEBUGLOGOUT
+  m_pcCuDecoder->m_cDebug.DebugLogFileClose();
+#endif
 
 }
